//-----------------------------------------------------------------------------
// mt_proc.h : MT֐
// Copyright (c) 2005-2008  N099
//-----------------------------------------------------------------------------
#pragma once

#include "sysdep.h"

#ifdef __cplusplus
extern "C" {
#endif

//茋
typedef struct _mov_dtc {
    short *mask;
    int frame;
} mov_dtc;

//LbV
typedef struct _mov_cache {
    mov_dtc mv[2];
    int h, w;
    short *temp;
    void *buf;
} mov_cache;

//MTp[^
typedef struct _mt_param {
    PIXEL_YC *edit, *temp;
    int fn;
    int th;
    int h, w, s;
    int top, btm;
} mt_param;

void mt_proc_lpf(int id, int num, void *para1, void *para2);
void mt_proc_abs(int id, int num, void *para1, void *para2);
void mt_proc_mov(int id, int num, void *para1, void *para2);
void mt_proc_blend(int id, int num, void *para1, void *para2);

void mt_proc_lpf_mmx(int id, int num, void *para1, void *para2);
void mt_proc_abs_sse(int id, int num, void *para1, void *para2);
void mt_proc_mov_sse(int id, int num, void *para1, void *para2);
void mt_proc_blend_sse(int id, int num, void *para1, void *para2);

void mt_proc_lpf_sse2(int id, int num, void *para1, void *para2);
void mt_proc_lpf_sse2u(int id, int num, void *para1, void *para2);
void mt_proc_abs_sse2(int id, int num, void *para1, void *para2);
void mt_proc_abs_sse2u(int id, int num, void *para1, void *para2);
void mt_proc_mov_sse2(int id, int num, void *para1, void *para2);
void mt_proc_blend_sse2(int id, int num, void *para1, void *para2);

void mt_proc_copy(int id, int num, void *para1, void *para2);

//global
extern mov_cache gmc;
extern __m128 grth;
extern volatile LONG gcnt[];

#ifdef __cplusplus
}
#endif
